//
//  DMDSDefinitions.m
//  DMDS Agent
//
//  Created by Karl Moskowski on 30/03/06.
//  Copyright 2006 Codeferous Software All rights reserved.
//

#if DEBUG==1
#define OXLog(format, ...) NSLog(@"%s:%@", __PRETTY_FUNCTION__,[NSString stringWithFormat:format, ## __VA_ARGS__]);
#define MARK	OXLog(@"%s", __PRETTY_FUNCTION__);
#define START_TIMER NSTimeInterval start = [NSDate timeIntervalSinceReferenceDate];
#define END_TIMER(msg) 	NSTimeInterval stop = [NSDate timeIntervalSinceReferenceDate]; OXLog([NSString stringWithFormat:@"%@ Time = %f", msg, stop-start]);
#else
#define OXLog(format, ...)
#define MARK
#define START_TIMER
#define END_TIMER(msg)
#endif

// VIDEO FORMAT
#define kBROADCAST_NTSC_SD                          @"0"
#define kBROADCAST_NTSC_HD                          @"1"
#define kBROADCAST_PAL_SD                           @"2"
#define kBROADCAST_PAL_HD                           @"3"
#define kBROADCAST_PREVIEW                          @"4"
#define kBROADCAST_LEGACY                           @"5"

// IDENTITY
#define kDMDSAgentName								@"DMDS App.app"
#define kDMDSAgentID								@"com.yangaroo.dmdsapp"
#define kDMDSUploadAgentID							@"com.yangaroo.dmdsupload"
#define kSocketRequestXMLRoot						@"downloadAsset"
#define kDMDSErrorDomain                            @"DMDSAgentError"

// NOTIFICATIONS

#define kDMDSAutoPollNowNotification                @"kDMDSAutoPollNowNotification"
#define kDMDSShowDownloadsWindowNotification        @"kDMDSShowDownloadsWindowNotification"
#define kDMDSCloseDownloadsWindowNotification       @"kDMDSCloseDownloadsWindowNotification"
#define kDMDSLoginCompleteNotification              @"kDMDSLoginCompleteNotification"
#define kDMDSLogoffNotification                     @"kDMDSLogoffNotification"
#define kDMDSPreferencesRequestNotification         @"kDMDSPreferencesRequestNotification"
#define kDMDSLaunchTracksLibraryNotification        @"KDMDSLaunchTracksLibraryNotification"
#define kDMDSAppIsQuittingNotification              @"kDMDSAppIsQuittingNotification"
#define kDMDSLoginCredentialsNotification           @"kDMDSLoginCredentialsNotification"
#define kDMDSLoginRequestNotification               @"kDMDSLoginRequestNotification"
#define kDMDSLoginNotification                      @"kDMDSLoginNotification"
#define kDMDSCloseDownloadsWindowNotification       @"kDMDSCloseDownloadsWindowNotification"
#define kDMDSShowDownloadsWindowNotification        @"kDMDSShowDownloadsWindowNotification"
#define kDMDSHelpPageRequestNotification            @"kDMDSHelpPageRequestNotification"
#define kDMDSBringAllToFronNotification				@"kDMDSBringAllToFronNotification"

#define kDMDSQTMovieDidEndNotification              @"kDMDSQTMovieDidEndNotification"
#define kDMDSQTMovieRateDidChangeNotification       @"kDMDSQTMovieRateDidChangeNotification"

#define kDMDSForceUploadQuitNotification            @"kDMDSForceUploadQuitNotification"
#define kDMDSBringAllToFronNotification				@"kDMDSBringAllToFronNotification"


// PERMISSIONS

#define kDMDSPermsManageRelease                     @"78"
#define kDMDSPermsManageAsset                       @"80"
#define kDMDSPermsUseAspera							@"82"

// BEHAVIOUR

#define kASDefaultTimeoutDurration					900
#define kASDefaultShortTimeoutDuration				60
#define kMaximumRetryAttempts						5
#define kURLTimeoutIntervalDefault					300

// SOCKET TAGS
#define kASDownloadMessageWrite						1
#define kASFileRead									2
#define kASDisconnectErrorRead						3

#define kASUploadMessageWrite						4
#define kASHeaderAcknowledgement					5
#define	kASUploadAcknowledgement					6
#define kASUploadWrite								8
#define kASDisconnectErrorWrite						9
#define kASUploadFinalWrite							10
#define kASUploadMD5CheckWrite						11
#define kASUploadMD5Acknowledgement					12
#define kASUploadCancelMessageWrite					13
#define kASUploadCancelAcknowledgement				14
#define kASUploadCommitMessageWrite					15
#define kASUploadCommitAcknowledgement				16
#define kASUploadCleanMessageWrite					17
#define kASUploadCleanAcknowledgement				18
#define kASUploadFileCompleteAcknowledgement		19

#define kSocketAcknowledgmentCode					@"ACK"
#define kSocketAcknowledgmentSuccessCode			@"ACK: Success"
#define kSocketAcknowledgmentErrorCode				@"ACK: ERROR"
#define kSocketRetryCode							@"RETRY"
#define kSocketEOLCode								@"ENDMSG"

#define kSocketMessageSize							2048

// DEFAULTS

#define kDmdsHostDefaultsKey                        @"dmdsHost"
#define kDmdsPortDefaultsKey                        @"dmdsPort"
#define kUseHttpsKey                                @"useHttps"
#define kUseHttpsForLoginKey						@"useHttpsForLogin"
#define kPollingIntervalDefaultsKey                 @"pollingInterval"
#define kDMDSUseAutoLoginKey						@"dmdsUseAutoLogin"
#define kOpenDMDSManagerWhenAutoLogin				@"openDMDSManagerWhenAutoLogin"
#define kNewTrackNotificationDefaultsKey            @"newTrackNotification"
#define kAutoCloseDownloadsWindowDefaultsKey        @"autoCloseDownloadsWindow"
#define kAutoLaunchAtLogin                          @"autoLaunchApp"
#define kAddDownloadedTracksToiTunesDefaultsKey     @"addDownloadedTracksToiTunes"
#define kiTunesPlaylistDefaultsKey                  @"iTunesPlaylist"
#define kDeleteAfteriTunesImportKey                 @"deleteAfteriTunesImport"
#define kDoNotRipOniTunesImportKey                  @"doNotRipOniTunesImport"
#define kAudioDownloadFolderDefaultsKey             @"audioDownloadFolder"
#define kVideoDownloadFolderDefaultsKey             @"videoDownloadFolder"
#define kXMLDownloadFolderDefaultsKey               @"xmlDowloadFolder"
#define kDownloadXMLFilesKey						@"downloadXMLFiles"
#define kMXFDownloadFolderDefaultsKey				@"mxfDowloadFolder"
#define kMoveMXFDownloadKey							@"moveMXFDownload"
#define kUNCDownloadFolderDefaultsKey				@"uncDowloadFolder"
#define kBypassVideoQAChecksDefaultsKey				@"bypassVideoQAChecks"
#define kPerformAdvVideoQAChecksDefaultsKey			@"performAdvVideoQAChecks"
#define kMonoVideoQAChecksDefaultsKey				@"monoVideoQAChecks"
#define kLevelsVideoQAChecksDefaultsKey				@"levelsVideoQAChecks"
#define kPhaseVideoQAChecksDefaultsKey				@"phaseVideoQAChecks"
#define kLoudnessVideoQAChecksDefaultsKey			@"loudnessVideoQAChecks"
#define kChromaVideoQAChecksDefaultsKey				@"chromaVideoQAChecks"
#define kFieldDomVideoQAChecksDefaultsKey			@"fieldDomVideoQAChecks"
#define kMoveUNCDownloadKey							@"moveUNCDownload"
#define kLastLoggedInUserKey                        @"lastLoggedInUser"
#define kLastLoggedInUserIDKey                      @"lastLoggedInUserID"
#define kSUCheckAtStartupKey                        @"SUCheckAtStartup"
#define kSUScheduledCheckIntervalKey                @"SUScheduledCheckInterval"
#define kURLTimeoutIntervalKey                      @"URLTimeoutInterval"
#define kQuitWithUploadAgent                        @"quitWithUploadAgent"
#define kOpenDMDSWebsiteAfterLoginKey				@"openDMDSWebsiteAfterLogin"
#define kDownloadAudioToReleaseFolderDefaultsKey	@"downloadAudioToReleaseFolder"
#define kDownloadVideoToReleaseFolderDefaultsKey	@"downloadVideoToReleaseFolder"
#define kDownloadVideoToSDHDFolderDefaultsKey       @"downloadVideoToSDHDFolder"
#define kEnableAutoDownloadKey						@"enableAutoDownload"
#define kDmdsUseiTunesForCDMetadata					@"useiTunesForCDMetadata"
#define kDefaultsXMLDownloadFormatKey               @"xmlDownloadFormat"
#define kDefaultsAsperaMaxRateKey                   @"asperaMaxRate"
#define kDefaultsValueApseraMaxRate                 10000
#define kDefaultsValueXMLFormatDMDS                 @"DMDS"
#define kDefaultsValueXMLFormatFlipFactory          @"Flip Factory"
#define kDefaultsValueiTunesPlaylistName            @"DMDS"
#define kDMDSDownloadSameAsFilePlaceholder          @"DMDSDownloadSameAsFile"
#define kDMDSManagerUsernameKey						@"dmdsManagerUsername"
#define kDMDSManagerServiceKey						@"DMDSManagerApp"
#define kDMDSMakeLocalCopyOnImportKey				@"DMDSMakeLocalCopyOnImport"
#define kDMDSHideLaunchHintWindowKey				@"DMDSHideLaunchHintWindow"
#define kDMDSWriteMP3ID3TagsKey						@"DMDSWriteMP3ID3Tags"
#define kDMDSFaspMaxUploadAttempts					@"asperaMaxUploadAttempts"
#define kDMDSMaxUploadSizeLimit						@"maxUploadSizeLimit"

// DEFAULTS - DEFAULT ATTRIBUTE VALUES

#define kADVUseAutoFill								@"ADVUseAutoFill"
#define kADVStartOfMessage							@"ADVStartOfMessage"
#define kADVLengthOfMessage							@"ADVLengthOfMessage"
#define kADVEndOfMessage							@"ADVEndOfMessage"
#define kADVProductionHouse							@"ADVProductionHouse"
#define kADVLanguage								@"ADVLanguage"
#define kADVProducer								@"ADVProducer"
#define kADVDistributor								@"ADVDistributor"
#define kADVPerformLengthCheck						@"ADVPerformLengthCheck"

#define kMVUseAutoFill								@"MVUseAutoFill"
#define kMVCopyrightDate							@"MVCopyrightDate"
#define kMVCopyrightOwner							@"MVCopyrightOwner"
#define kMVReleaseYear								@"MVReleaseYear"
#define kMVLanguage									@"MVLanguage"
#define kMVProdCompany								@"MVProdCompany"
#define kMVProducer									@"MVProducer"
#define kMVDirector									@"MVDirector"
#define kMVCinematographer							@"MVCinematographer"
#define kMVProdHouse								@"MVProdHouse"
#define kMVDistributor								@"MVDistributor"
#define kMVPublisher								@"MVPublisher"
#define kMVRightsSociety							@"MVRightsSociety"

#define kPreferencesContext                         @"PreferencesContext"


#define kURLTimeoutInterval 						[[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kURLTimeoutIntervalKey] floatValue]

#define kURLScheme 									([[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kUseHttpsKey] boolValue] ? @"https" : @"http")
#define kURLLoginScheme								([[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kUseHttpsForLoginKey] boolValue] ? @"https" : @"http")
#define kHostAndPort 								[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kDmdsHostDefaultsKey]

#define kCurrentAudioDownloadFolder 				[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kAudioDownloadFolderDefaultsKey]
#define kCurrentVideoDownloadFolder 				[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kVideoDownloadFolderDefaultsKey]
#define kCurrentXMLDownloadFolder 					[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kXMLDownloadFolderDefaultsKey]
#define kCurrentMXFDownloadFolder 					[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kMXFDownloadFolderDefaultsKey]
#define kCurrentUNCDownloadFolder 					[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kUNCDownloadFolderDefaultsKey]

#define kEnableAutoDownload							[[[[NSUserDefaultsController sharedUserDefaultsController] values] valueForKey:kEnableAutoDownloadKey] boolValue]
#define kDMDSMakeLocalCopyOnImport					[[NSUserDefaults standardUserDefaults] boolForKey:kDMDSMakeLocalCopyOnImportKey]

#define kAudioCDFilesystemID                        (UInt16)(('J' << 8) | 'H' )
//#define charsToStripFromTrackFileName               @"()*&^%$#@!\"':;<>,.?/{}[]\\|+="
#define kIllegalFileNameCharacters                  @"()*&^%$#@!\"':;<>,.?/{}[]\\|+="
#define kDMDSUploadURLKey                           @"DMDSUploadURL"
#define kAgentType                                  @"1"
#define kWebMethodsBase                             @"/DMDS.WebApp.Public"
#define kWebMethodsFull                             @"/DMDS.WebApp.Public/Services/AgentServices.asmx"
#define kWebDownloadMethodsFull						@"/DMDS.WebApp.Public/Services/AgentDownloadServices.asmx/"
#define kSchemaVersion                              @"1"
#define kWebUserLandingPage							@"/DMDS.WebApp.Public/Manager/Agent/LaunchPage/AgentLaunchPage.aspx?agentTokenID=%@"

#define kAssetType_Audio                            @"Audio"
#define kAssetType_Video                            @"Video"
#define kAssetType_Image                            @"Image"
#define kAssetType_Document                         @"Document"

#define kContactListID                              [[NSApp delegate] contactListId]
#define kMaxLoadQTMovieSize                         [NSNumber numberWithInt:1024*1024*150]
#define kMD5HashChunkSize							(1024*1024)
#define kUploadChunkSize                            (1024*1024*2)
#define kUploadAttemptMax                           2
#define kDMDSUploadSizeLimit                        3221225472U
#define kDMDSUploadItemCountLimit                   100
#define kDMDSMinimumAssetDurration					30U

#define kFASP_UploadAttemptMax						5
#define kFASP_UploadPogressNotification				@"FASP_UploadPogressNotification"
#define kFASP_UploadErrorNotification				@"FASP_UploadErrorNotification"

#define kFASP_JobID									@"FASP_JobID"
#define kFASP_JobState								@"FASP_JobState"
#define kFASP_JobSrcPath							@"FASP_JobSrcPath"
#define kFASP_JobDestPath							@"FASP_JobDestPath"
#define kFASP_PercentUploadCompleted				@"FASP_PercentUploadCompleted"
#define kFASP_EventCode								@"FASP_EventCode"
#define kFASP_TotalTransferredBytes					@"FASP_TotalTransferredBytes"
#define kFASP_EventCodeIsFileStop					@"FASP_EventCodeIsFileStop"
#define kFASP_EventCodeIsSessionStart				@"FASP_EventCodeIsSessionStart"
#define kFASP_EventCodeIsSessionError				@"FASP_EventCodeIsSessionError"
#define kFASP_SessionErrorIsUserCanceled			@"FASP_SessionErrorIsUserCanceled"
#define kFASP_SessionErrorDescription				@"FASP_SessionErrorDescription"
#define kFASP_TotalElapsedMSec						@"FASP_TotalElapsedMSec"
#define kFASP_TotalWrittenBytes						@"FASP_TotalWrittenBytes"
#define kFASP_SessionErrorCode						@"FASP_SessionErrorCode"
#define kFASP_MeasuredLinkRateKbps					@"FASP_MeasuredLinkRateKbps"
#define kFASP_TransferRateBps						@"FASP_TransferRateBps"
#define kFASP_EventCodeIsRateModification			@"FASP_EventCodeIsRateModification"
#define kFASP_EventCodeIsProgress					@"FASP_EventCodeIsProgress"
#define kFASP_EventCodeIsSessionStop				@"FASP_EventCodeIsSessionStop"

#define kFASP_FileSize								@"FASP_FileSize"
#define kFASP_FileWrittenBytes						@"FASP_FileWrittenBytes"

#define kSessionErrorUserCanceled					@"User aborted session"
#define kSessionErrorCode_UserCanceled				28

#define kFASP_User									@"dmdsAspera"

#define FASP_TARGET_RATE							10000    /* Target (max) transfer rate in Kbps */
#define FASP_MIN_RATE								1000     /* Minimum transfer rate in Kbps - adaptive rate only */
#define FASP_CREATE_DIRS							false    /* Create the target directory if it does not exist   */
#define FASP_UPDATE_RATE_INTERVAL					1000

#define kDMDSSocketUploadChunkSize					65536

#define	kMUSICProductCode							@"4"
#define kADProductCode								@"3"
#define kJUNOProductCode							@"2"
#define kGRAMMYProductCode							@"1"

#define kSparkleAppPath								[[[NSBundle mainBundle] infoDictionary] objectForKey:@"DMDSSparkleFeedPath"]
#define kSparkleAppcastFileName						[[[NSBundle mainBundle] infoDictionary] objectForKey:@"DMDSSparkleAppcastFileName"]

#define kQATesterLogFilePath						@"/Library/Logs/qatester.log"
#define kQATestLevelBasic							0
#define kQATestLevelAdv								1
