//
//  FileUtilities.h
//  DMDSUpload
//
//  Created by David LeBer on 27/07/07.
//  Copyright 2007-2008 Codeferous Software. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import <QTKit/QTKit.h>

@class MyQTMovie;
@class QTMovie;

@interface FileUtilities : NSObject {

}

+ (BOOL) fileTypeIsAcceptable:(NSString*)path;
+ (BOOL) fileTypeRequiresTranscoding:(NSString*)path;
+ (BOOL) fileTypeIsVideo:(NSString*)path;
+ (BOOL) fileTypeIsAudio:(NSString*)path;
+ (BOOL) fileTypeIsImage:(NSString*)path;
+ (BOOL) fileUTI:(CFStringRef)itemUTI conformsToItemInArray:(NSArray*)typeArray;
+ (BOOL) fileUTIIsProtectedAudio:(CFStringRef)uti extension:(NSString *)extension;
+ (BOOL) fileUTIIsAudio:(CFStringRef)uti extension:(NSString *)extension;
+ (BOOL) fileUTIIsWav:(CFStringRef)uti extension:(NSString *)extension;
+ (BOOL) fileUTIIsVideo:(CFStringRef)uti extension:(NSString *)extension;
+ (BOOL) fileUTIIsImage:(CFStringRef)uti extension:(NSString *)extension;
+ (BOOL) fileUTIIsDocument:(CFStringRef)uti extension:(NSString *)extension;
+ (MyQTMovie *) movieForPath: (NSString *)filePath;
+ (QTMovie *) qtMovieForPath: (NSString *)filePath;
+ (NSMutableDictionary *) metadataForMediaAssetFromMovie: (MyQTMovie *)movie;
+ (NSNumber *) fileSizeForPath:(NSString *)path;
+ (BOOL) volumeForPathIsCD:(NSString*)path;
+ (BOOL) filePathIsUnique:(NSString*)path inManagedObjectContext:(NSManagedObjectContext *)context;
+ (BOOL) createDirectoryAtPath:(NSString*)path withOverwriting:(BOOL)overwrite;
+ (NSString *) cleanFileName:(NSString *)fileName;
+ (NSString *) removeCharacters:(NSString *)charString fromString:(NSString* )str;
+ (NSString *) uniqueString;

@end
